
uchar WaitForCommandByteE2() {
   int Byter=0;
   Byter=TakeByte();

   printf("%x",Byter);
   fflush(stdout);

   if (Byter==-1)
      return (0xEE);
   else
       return (Byter);



   }




void WriteDataCmdE2(){
   int i,j;
   uint PageNum;
   uint FirstByte;
   uint SizeB1,SizeB2,SizeOfData;

   printf(": Write Data\n");
   fflush(stdout);

   PageNum=(TakeByte()*256+TakeByte())>>1;
   FirstByte=TakeByte();
   SizeB1=TakeByte();
   SizeB2=TakeByte();
   SizeOfData=(SizeB2==0x80)?(SizeB1):(SizeB1+SizeB2);

   printf("Page:%x First:%x Size:%x\n",PageNum,FirstByte,SizeOfData);


   for (i=FirstByte;i<(FirstByte+SizeOfData);i++)
       pagebuffer[i]=(uchar)TakeByte();
   CopyPage(veiipage[PageNum].bytes,pagebuffer);


   printf("Writecount: %d\n",++veiipage[PageNum].writecount);


   return;


   }

void ReadDataCmdE2(){
   uint PageNum=0;
   uint FirstByte, SizeB1, SizeB2;
   uint SizeOfData=0;
   int i,j;


   printf(": Read Data\n");
   fflush(stdout);

   PageNum=(TakeByte()*256+TakeByte())>>1;
   FirstByte=TakeByte();
   SizeB1=TakeByte();
   SizeB2=TakeByte();


   SizeOfData=(SizeB2==0x80)?(SizeB1):(SizeB1+SizeB2);


   printf("Page:%x First:%x Size:%x\n",PageNum,FirstByte,SizeOfData);


   CopyPage(pagebuffer,veiipage[PageNum].bytes);
   for (i=FirstByte;i<(FirstByte+SizeOfData);i++)
       PushByte(pagebuffer[i]);
   return;

   }

void SendString(char *strpt) {
     int i;
     for (i=0;i<strlen(strpt);i++)
         PushByte(strpt[i]);
     }


void MemChipStatReqE2(){
	printf(": Memory Chip Status Request\n");
	 PushByte(0x57);
	 return;
     }
void DeviceRevReqE2(){
     printf(": EII Firmware Revision code request\n");
	 PushByte(FAKEEIIVER);
	 return;
     }
void CpyRtReqE2(){
      printf(": Copyright Request\n");
      fflush(stdout);

      SendString("Virtual EII Copyright (C) 1998-1999 by ie & JK.  Thanks to: BR,MS,PF,MH,GM,DB,JH,PB,ML");

     return;
     }

void ModPortInvalid(){
	printf(": Mod Port Access\n");
	ShowErrMsg("e2rout","ModPortInvalid",-1,"","Mod Port Use Not Allowed");
     return;
     }


void LoadVImage(char *filename)
	 {
     int i,j;
     FILE *veiifile;

     
     veiifile=fopen(filename,"r");
     if (veiifile==NULL)
		{
		 ShowErrMsg("main","LoadVImage",-1,filename,"File Does Not Exist.");		
		 return;
		}
	 for (i=0;i<MAXPAGE;i++)
         for (j=0;j<264;j++)
             veiipage[i].bytes[j]=getc(veiifile);
     fclose(veiifile);
	
	 ShowErrMsg("main","LoadVImage",-1,filename,"File loaded succesfully.");


	 }


void SaveVImage(char *filename) 
     {
     int i,j;
     FILE *veiifile;



     veiifile=fopen(filename,"w");
     for (i=0;i<MAXPAGE;i++)
         for (j=0;j<264;j++)
             putc(veiipage[i].bytes[j],veiifile);
     fclose(veiifile);

     ShowErrMsg("main","SaveVImage",-1,filename,"File saved succesfully.");
	 
	 }





void ShowVStats(int typo)
	{
	ShowErrMsg("e2rout","ShowVStats",typo,"","Virtual EII Statistics not yet available");

	}

void ShowRStats(int typo)
	{
	ShowErrMsg("e2rout","ShowRStats",typo,"","Real EII Statistics not yet available");
	}

void FormatR()
	{
	ShowErrMsg("e2rout","FormatR",-1,"FormatRealEIIAttempt","Feature not yet available");
	}

void SaveRImage(char *fnamer)
	{
	ShowErrMsg("e2rout","SaveRImage",-1,fnamer,"Feature not yet available");
	}

void LoadRImage(char *fnamer)
	{
	ShowErrMsg("e2rout","LoadRImage",-1,fnamer,"Feature not yet available");
	}

void TransferRealVirtual()
	{
	ShowErrMsg("e2rout","TransferRealVirtual",-1,"","Feature not yet available");
	}

void TransferVirtualReal()
	{
	ShowErrMsg("e2rout","TransferVirtualReal",-1,"","Feature not yet available");
	}

void ImportToFake(char *fnamer,char *enamer)
	{
	ShowErrMsg("e2rout","ImportToFake",-1,fnamer,"Feature not yet available");
	}

void ImportToReal(char *fnamer,char *enamer)
	{
	ShowErrMsg("e2rout","ImportToReal",-1,fnamer,"Feature not yet available");
	}

void ExportFromFake(char *fnamer, char *enamer)
	{
	ShowErrMsg("e2rout","ExportFromFake",-1,enamer,"Feature not yet available");
	}

void ExportFromReal(char *fnamer,char *enamer)
	{
	ShowErrMsg("e2rout","ExportFromReal",-1,enamer,"Feature not yet available");
	}

void FormatV() {

    int i,j;
    for (i=0;i<MAXPAGE;i++) {
        veiipage[i].writecount=0;
        for (j=0;j<264;j++)
            veiipage[i].bytes[j]=0xFF;
        }
    ShowErrMsg("main","FormatV",-1,"","Virtual EII Format Complete.");
	return;


	 }