#define MAXPAGE 2050
#define NUMCOMMANDS 71
#define uint unsigned int
#define uchar unsigned char
#define bool uchar
#define true 1
#define false 0



#define FAKEEIIVER 0xFE


#define ESC_PRSS_CMD 0xEE  /*could be forced by calc!! hehe*/
#define DAT_WRIT_CMD 0x82
#define DAT_READ_CMD 0x52
#define CNT_STTM_CMD 0x57
#define CNT_REV2_CMD 0xFF
#define CNT_CPYR_CMD 0x43
#define MOD_SEND_CMD 0x21
#define MOD_RECV_CMD 0x20
#define MOD_DIRC_CMD 0x22




char *Commands[71]={
     "version","ver","c","credit","credits", /*0-4*/
     "help","h","?",/*5-7*/
     "open","load","o","l","restore","vopen","vload","vo","vl","vrestore",/*8-17*/
     "save","s","backup","b","vsave","vs","vbackup","vb",/*18-25*/
     "format","f","vformat","vf",/*26-29*/
     "stats","vstats",/*30-31*/
     "port","a",/*32-33*/
     "link",/*34-34*/
     "slevel","sl",/*35-36*/
     "dlevel","dl",/*37-38*/
     "rformat","rf",/*39-40*/
     "rstats",/*41-41*/
     "ropen","rload","ro","rl","rrestore",/*42-46*/
     "rsave","rs","rbackup","rb",/*47-50*/
     "transferrv","trv",/*51-52*/
     "transfervr","tvr",/*53-54*/
     "import","vimport","i","vi",/*55-58*/
	"rimport","ri",/*59-60*/
	"export","vexport","e","ve",/*61-64*/
	"rexport","re",/*65-66*/
	"exit","quit","q","abort"/*67-70*/
	};
/*									 1 1 1 1 1 1 1 1 1 1 2 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3  3  3  3  4  4  4  4  4  4  4  4  4  4  5  5  5  5  5  5  5  5  5  5  6  6  6  6  6  6  6  6  6  6  7  
/*				 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  */
int cmdnums[71]={1,1,1,1,1,2,2,2,3,3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,6,6,7,7,8,9,9,10,10,11,11,12,13,13,13,13,13,14,14,14,14,15,15,16,16,17,17,17,17,18,18,19,19,19,19,20,20,21,21,21,21};


uint PORT=0x2f8;
uint PORTTYPE=0x0000;   /* 0=com-port, 1=lpt-port*/
uint StatLev=0;
uint DebLev=0;

	struct ManyMan{
		int commandnum;
		int arg1;
		int arg2;
		char arg1s[80];
		char arg2s[80];
		};


struct aneii {
       uchar bytes[264];
       int writecount;
       } veiipage[MAXPAGE];
uchar pagebuffer[264];


void ShowVersion();
void InterpretArgs(int ,char **);
void EmulationNow();
void ShowErrMsg(char *,char *,int,char *,char *);
void ShowHelp(int);

void LoadVImage(char *);
void LoadRImage(char *);
void SaveVImage(char *);
void SaveRImage(char *);
void FormatV();
void FormatR();
void ShowVStats(int);
void ShowRStats(int);

void TransferRealVirtual();
void TransferVirtualReal();

void EmulateE2();
void ParseCommandLine(char *,struct ManyMan *);
bool ProcessCommandLine(struct ManyMan *);

uint GetByte(void);
uint SendByte(uchar);
void initport(void);
void SSendByte(uchar);
void SInitPort(void);
uint SGetByte(void);



void CopyPage(void *dest, void *source) {
   memcpy(dest,source,264);


   }

uint TakeByte(void)
	{
	if (PORTTYPE==2)
		return(SGetByte());
	else
		return(GetByte());
	}

void IzePort(void)
	{
	if (PORTTYPE==2)
		{
		SInitPort();
		return;
		}
	else
		{
		initport();
		return;
		}
	}

void PushByte(uchar sendt)
	{
	if (PORTTYPE==2)
		{
			SSendByte(sendt);
			return;
		}
	else
		{
		SendByte(sendt);
		return;
		}
	}
