void ParseCommandLine(char *commandline,struct ManyMan *cmdstrct)
	{
	int i,j,slen;
	char cmdarg[80];
	char *dum;

	i=-1;
	slen=strlen(commandline);
	commandline[--slen]='\0';



	while((i<=slen)&&(commandline[++i]==' '));
	
	j=0;
	while((commandline[i]!=' ')&&(i<=slen))
		cmdarg[j++]=commandline[i++];
	cmdarg[j]=0;
	
	while((i<=slen)&&(commandline[++i]==' '));
	
	j=0;
	while((commandline[i]!=' ')&&(i<=slen))
		cmdstrct->arg1s[j++]=commandline[i++];
	cmdstrct->arg1s[j]=0;
	
	while((i<=slen)&&(commandline[++i]==' '));
	
	j=0;
	while((commandline[i]!=' ')&&(i<=slen))
		cmdstrct->arg2s[j++]=commandline[i++];
	cmdstrct->arg2s[j]=0;
	
	
	

	/*now i have to convert a command --string-- into a command --number--!!!*/

	cmdstrct->arg1=(int)strtol(cmdstrct->arg1s,&dum,0);
	cmdstrct->arg2=(int)strtol(cmdstrct->arg2s,&dum,0);

	cmdstrct->commandnum=0;
	for (i=0;i<NUMCOMMANDS;i++)
		if (!stricmp(cmdarg,Commands[i]))
			{
			cmdstrct->commandnum=cmdnums[i];
			break;
			}
	if (cmdstrct->commandnum==0)
		ShowErrMsg("e2genrout","ParseCommandLine",-1,cmdarg,"Bad Command.  No such command exists.");
	
	return;
	
}




void ShowHelp(int pager)
		{
		switch(pager)
			{ 
			case 3:
				{
				printf("\nHelp\t(3)\t\t\t\t\t\tCLI Usage\n\n");
				printf("e2emu32 [-Ltype] [-Aport] [-Sn] [-Dn] [-Ffilename]\n\n");
				printf("Ltype\t-Use Link type. type can be:\n");
				printf("\tHS(default) Homemade Serial Link (HP)Homemade Parallel (G)TI-GraphLink\n");
				printf("Aport\t-Use port number port  0x2F8(default)\n");
				printf("Sn\t-Use n level Stat Coverage 0(default)\n");
				printf("Dn\t-Use n level Debugging 0(default)\n");
				printf("Ffile\t-Load file into Virtual EII space upon starting\n\n");

				break;
				}
			case 2:
				{
            printf("\nHelp\t(2)\t\t\t\t\t\tInternal Commands\n\n");
				printf("Here are the internal commands that can be used.  Experiment, sometimes \n");
				printf("abbreviations can work as well, but be aware that sometimes the abreviation\n");
				printf("may not do as planned... Also, all vxxxx commands work as xxxx as well.\n\n");
				printf("Full Command\t\tArg1\tArg2\t\tDescription\n");
				printf("version,credits\t\t\t\t\tShow version and credit info\n");
				printf("help,?\t\t\tpagenumber\t\tShow the help screen pagenumber\n");
				printf("exit,quit,abort\t\t\t\t\tQuits the Emulator\n");
				printf("port,a\t\t\tportnumber\t\tSets the link port address\n");
				printf("link\t\t\tlinktype\t\tSets the link type\n");
				printf("slevel\t\t\tlevel\t\t\tSets the Statistical Level\n");
				printf("dlevel\t\t\tlevel\t\t\tSets the Debugging Level\n");
				printf("vopen,vload,vrestore\tfile\t\t\tLoad VEII from file\n");
				printf("ropen,rload,rrestore\tfile\t\t\tLoad REAL EII from file\n");
				printf("vsave,vbackup\t\tfile\t\t\tSave the VEII contents to file\n");
				printf("rsave,rbackup\t\tfile\t\t\tSave the EII contents to file\n");
				printf("vformat\t\t\t\t\t\tFormat the VEII\n");
				printf("rformat\t\t\t\t\t\tFormat the Real EII\n");
				printf("vstats\t\t\t\t\t\tShow statistics of the VEII\n");
				printf("rstats\t\t\t\t\t\tShow statistics of real EII\n");
				printf("transferrv\t\t\t\t\tTransfer Real EII->VEII\n");
				printf("transfervr\t\t\t\t\tTransfer VEII->Real EII\n");
				printf("vimport\t\t\tfile\tefile\t\tImport file to veii as efile\n");
				printf("rimport\t\t\tfile\tefile\t\tImport file to EII as efile\n");
				printf("vexport\t\t\tefile\tfile\t\tExport efile from veii to file\n");
				printf("rexport\t\t\tefile\tfile\t\tExport efile from EII to file\n\n");
				break;
				}
			default:
				{
				printf("\nHelp (1)\t\t\t\t\t\tHelp Contents\n\n");
				printf("type:\thelp page  to access the different help pages.\n\n");
				printf("page\tWhats on it\n");
				printf("1\tThis page, the contents of help\n");
				printf("2\tListing and explaination of internal command set\n");
				printf("3\tDesciption of the Command Line interface and options\n\n");
				break;
				}
			}
		return;
		}


void ShowVersion()
	{
	printf("\nE2Emu32 version %s\n",version);
	printf("Copyright (C) 1998-1999, Jonathan Kaus and Ingenious Engineering\n");
	printf("The EII was developed by Bryan Rittmeyer, who holds the copyright to the EII\n\tfirmware.\n");
	printf("Thanks to:  Bryan Rittmeyer, Magnus Svedin, Per Finander, Magnus\n\tHagander, Gary Marsh, David Booser, Pascal Bouron, Mattias \n\tLindquist, and Jani Halme.\n\n");
	return;

	}

void InterpretArgs(int argc,char **argv)
	{
    int i;
	char *dum;
	
	FormatV();

        
	for (i=1;i<argc;i++)
		if (argv[i][0]=='-')
            {
            strupr(argv[i]);
			switch (argv[i][1])
					{
					case 'L':
						if (argv[i][2]=='H')
							PORTTYPE=(argv[i][3]=='S')?0:1;
						if (argv[i][2]=='G')
							PORTTYPE=2;
						break;
					case 'A':
						PORT=(int)strtol(&argv[i][2],&dum,0);
						break;
					case 'S':
						StatLev=atoi(&argv[i][2]);
						break;
					case 'D':
						DebLev=atoi(&argv[i][2]);
						break;
					case '?':
						ShowHelp(3);
						ShowErrMsg("e2genrout","exit",1,"","Help Requested.");
						exit(1);
					case 'F':
						LoadVImage(&argv[i][2]);
						break;
						
                    default:
						ShowErrMsg("e2genrout","InterpretArgs",-1,argv[i],"Bad Argument");
                    }
			}
		else
			ShowErrMsg("e2genrout","InterpretArgs",-1,argv[i],"Bad Argument");


	return;
	}


bool ProcessCommandLine(struct ManyMan *cn)
	{
	switch(cn->commandnum)
		{
		case 1:
			ShowVersion();
			break;
		case 2:
			ShowHelp(cn->arg1);
			break;
		case 3:
			LoadVImage(cn->arg1s);
			break;
		case 4:
			SaveVImage(cn->arg1s);
			break;
		case 5:
			FormatV();
			break;
		case 6:
			ShowVStats(cn->arg1);
			break;
		case 7:
			PORT=cn->arg1;
			break;
		case 8:
			switch (cn->arg1s[0])
				{
				case 'g':
					PORTTYPE=2;
					break;
				case 'G':
					PORTTYPE=2;
					break;
				case 'h':
					if ((cn->arg1s[1]=='S')||(cn->arg1s[1]=='s'))
						PORTTYPE=0;
					else
						PORTTYPE=1;
					break;

				case 'H':
					if ((cn->arg1s[1]=='S')||(cn->arg1s[1]=='s'))
						PORTTYPE=0;
					else
						PORTTYPE=1;
					break;
				
				}

			break;
		case 9:
			StatLev=cn->arg1;
			break;
		case 10:
			DebLev=cn->arg1;
			break;
		case 11:
			FormatR();
			break;
		case 12:
			ShowRStats(cn->arg1);
			break;
		case 13:
			LoadRImage(cn->arg1s);
			break;
		case 14:
			SaveRImage(cn->arg1s);
			break;
		case 15:
			TransferRealVirtual();
			break;
		case 16:
			TransferVirtualReal();
			break;
		case 17:
			ImportToFake(cn->arg1s,cn->arg2s);
			break;
		case 18:
			ImportToReal(cn->arg1s,cn->arg2s);
			break;
		case 19:
			ExportFromFake(cn->arg1s,cn->arg2s);
			break;
		case 20:
			ExportFromReal(cn->arg1s,cn->arg2s);
			break;
		case 21:
			return(false);
		default:
		}
	return(true);
	}


void ShowErrMsg(char *section,char *proc,int valueint,char *valuestr,char *message)
	{
	printf("e2emu32: %s: %s: ",section,proc);
	if (valueint==-1)
		printf("%s: %s\n",valuestr,message);
	else
		printf("%x: %s\n",valueint,message);
	return;
	}

